#datalink.py
import serial
import time
import threading
import wx
import log

class radiolink(object):
	def __init__(self,parent,in_port,out_port):		
		self.parent = parent
		self.thread = None
		self.alive = threading.Event()
		self.radio = serial.Serial(in_port,4800,timeout = 0)
		self.gpsout = serial.Serial(out_port,4800,timeout = 0)
		self.stik = self.parent.stik
		#error handling for missing ports done in main
		
	def StartThread(self):
		self.thread = threading.Thread(target=self.CommThread)
		self.thread.setDaemon(1)
		self.alive.set()
		self.thread.start()
				
	def StopThread(self):
		if self.thread is not None:
			self.alive.clear()
			self.thread.join()
			self.thread = None
			
	def CommThread(self):
		while(self.alive.isSet()):
			#input
			buffer = self.radio.readline()
			if buffer:
				self.gpsout.write(buffer)
				print buffer
				#log.Log('d',buffer) #why does this crash?
				buffer = buffer.split(',')
				kind = buffer[0]
				if kind == "$GPRMC":
					if len(buffer) != 13:
						#malformed nmea sentence
						print 'skipping',buffer
						continue
					else:
						try:
							time_acq = int(buffer[1]) #utc
							lat = buffer[3].split('.')
							lat_deg = int(lat[0][:-2])
							lat_min = int(lat[0][-2:]) + float(lat[1])/(10**len(lat[1]))
							lat_dir = buffer[4]
							lon = buffer[5].split('.')
							lon_deg = int(lon[0][:-2])
							lon_min = int(lon[0][-2:])+ float(lon[1])/(10**len(lon[1]))
							lon_dir = buffer[6]
							speed = float(buffer[7]) #knots
							course = -1*float(buffer[8]) #convert to deg CW from N
						except Exception,e:
							print e,buffer
					
					self.parent.UpdatePositionInfo(str(lat_deg),str(lat_min),str(lat_dir),
						str(lon_deg),str(lon_min),str(lon_dir))
					self.parent.UpdateAirspeed(str(speed)+' kt')
					#self.parent.compass.SetHeading(course) #weird crashes
						#why?
					#lat_string = "%2id %2f' %s" % (lat_deg,lat_min,lat_dir)
					#lon_string = "%2id %2f' %s" % (lon_deg,lon_min,lon_dir)
					#lat_deg,'d',lat_min,'m',lat_sec,'s',lat_dir
					#lon_string = lon_deg,'d',lon_min,'m',lon_sec,'s',lon_dir	
					#print lat_string,lon_string
				if kind == "$PGRMZ":
					altitude = buffer[1] #feet
					self.parent.UpdateAltitude(str(altitude)+' ft')
				#if kind == "$HCHDG":
					#only present on Garmin eTrex, Vista and GPS76S
					#magnetic value
				#	heading = buffer[1]
				#	deviation = buffer[2]
					#self.parent.compass.SetHeading(heading)
				if kind == "$GPRMB":
					pass
					#todo
				else:
					pass
					
			#output					
		#	(x,y) = self.stik.getPos()
		#	t = self.stik.getThrottle()
			#init locals
		#	i,j,k = '','',''
			
		#	if x < 0:
		#		i = 'L %3i\n' % (abs(x)*(255./100))
		#	if x > 0:
		#		i = 'R %3i\n' % (abs(x)*(255./100))
			#y-axis is reversed, for standard flight controls
		#	if y > 0: 
		#		j = 'D %3i\n' % (abs(y)*(255./100))
		#	if y < 0: 
		#		j = 'U %3i\n' % (abs(y)*(255./100))
		#	k = 'T %3i\n' % (abs(t)*(255./100))
		#	out_string = ''.join([i,j,k])
			#self.gpsout.write(out_string)
			#print out_string,'---'
			#log.Log('u',out_string)
			time.sleep(.25) #GPS signal comes in at 1hz, so no need to overdo our refresh