import wx
import os

class PrefFrame(wx.MiniFrame):
	def __init__(self, *args, **kwds):
		wx.MiniFrame.__init__(self, *args, **kwds)
		self.parent = self.GetParent()
		mainsizer = wx.BoxSizer(wx.VERTICAL)
		portsizer = wx.FlexGridSizer(2,2)
		self.gpsout_port_ctrl = wx.ComboBox(self,-1,'',size=(175,30))
		self.radio_port_ctrl = wx.ComboBox(self,-1,'',size=(175,30))
		portsizer.Add(wx.StaticText(self,-1,"Radio Port"),0)
		portsizer.Add(self.radio_port_ctrl,1)
		portsizer.Add(wx.StaticText(self,-1,"GPS Out Port"),0)
		portsizer.Add(self.gpsout_port_ctrl,1)
		ports = self.GetSerialPorts()
		for port in ports:
			self.gpsout_port_ctrl.Append(port)
			self.radio_port_ctrl.Append(port)
		save = wx.Button(self,-1,"Apply")
		save.SetDefault()
		mainsizer.Add(portsizer,0,wx.LEFT|wx.TOP|wx.RIGHT,3)
		mainsizer.Add(save,0,wx.ALIGN_CENTER_HORIZONTAL|wx.BOTTOM|wx.TOP,5)
		self.SetSizer(mainsizer)
		wx.EVT_BUTTON(self,save.GetId(),self.OnSave)
		#wx.EVT_CLOSE(self,self.OnClose)

	def OnSave(self,evt):
		self.parent.gpsout_port = self.gpsout_port_ctrl.GetValue()
		self.parent.radio_port = self.radio_port_ctrl.GetValue()
	 
	def GetSerialPorts(self):
		if "__WXMAC__" in wx.PlatformInfo:
			d = os.listdir('/dev')
			l = []
			for i in d:
				if (('serial' in i) or ('Serial' in i)) and ('tty' in i):
					l.append('/dev/'+i)
			return l
		else:
			pass
			#figure out what to do on other platforms